package io.tswf.groovy.bettergroovy.asm.view.exception

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.view.generation.IViewMethodMapper
import io.tswf.groovy.bettergroovy.asm.view.meta.ViewMethodMetadata

@CompileStatic
class MultipleViewMethodMappersFoundException extends RuntimeException {
    ViewMethodMetadata viewMethodMeta
    List<IViewMethodMapper> foundMappers

    MultipleViewMethodMappersFoundException(ViewMethodMetadata viewMethodMeta, List<IViewMethodMapper> foundMappers) {
        super("There is multiple view method mappers found for ${viewMethodMeta.viewMethod.javaFullName} in ${viewMethodMeta.view.viewClass.javaName}: ${foundMappers.map { it.class.name }}. Each method must have single mapper! Maybe you add multiple mapping annotations?")
        this.viewMethodMeta = viewMethodMeta
        this.foundMappers = foundMappers
    }
}
