package io.tswf.groovy.bettergroovy.asm.view.exception

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.view.meta.ViewMethodMetadata
import io.tswf.groovy.bettergroovy.asm.view.reading.ViewMethodMetadataReader

@CompileStatic
class NoViewMethodMapperFoundException extends RuntimeException {
    ViewMethodMetadata viewMethodMeta

    NoViewMethodMapperFoundException(ViewMethodMetadata viewMethodMeta) {
        super("There is no method mapper found for ${viewMethodMeta.viewMethod.javaFullName} in ${viewMethodMeta.view.viewClass.javaName} in readers ${ViewMethodMetadataReader.methodMapperReaders}!")
        this.viewMethodMeta = viewMethodMeta
    }
}
