package io.tswf.groovy.bettergroovy.asm.view.generation.conflict

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.view.meta.ViewConflictResolveStrategy
import io.tswf.groovy.bettergroovy.asm.view.meta.ViewMethodMetadata
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.MethodNode

@CompileStatic
interface IViewConflictResolveLogic {
    ViewConflictResolveStrategy getEnumValue()
    void handleConflictResolve(ConflictResolveContext resolveContext)
}

@CheckedMapConstructor
@CompileStatic
class ConflictResolveContext {
    ViewMethodMetadata viewMethodMeta
    ClassNode targetClass
    MethodNode conflictingMethod
    boolean passed = false
}