package io.tswf.groovy.bettergroovy.asm.view.generation.conflict

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import groovy.util.logging.Slf4j
import io.tswf.groovy.bettergroovy.asm.view.exception.ConflictingMethodFoundException
import io.tswf.groovy.bettergroovy.asm.view.meta.ViewConflictResolveStrategy

@Slf4j
@AutoService(IViewConflictResolveLogic)
@CompileStatic
class ThrowViewConflictResolver implements IViewConflictResolveLogic {

    @Override
    ViewConflictResolveStrategy getEnumValue() {
        return ViewConflictResolveStrategy.THROW
    }

    @Override
    void handleConflictResolve(ConflictResolveContext resolveContext) {
        throw new ConflictingMethodFoundException(resolveContext.targetClass, resolveContext.conflictingMethod, resolveContext.viewMethodMeta.view.viewClass, resolveContext.viewMethodMeta.viewMethod)
    }
}
