package io.tswf.groovy.bettergroovy.asm.view.meta

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.view.generation.IViewMethodMapper
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.Type
import org.objectweb.asm.tree.MethodNode

@CheckedMapConstructor
@CompileStatic
class ViewMethodMetadata {
    // Если у каждой метадаты метода будет только один тип цели, то это позволит делать ремаппинг в read-time
    Type targetType
    ViewMetadata view
    MethodNode viewMethod
    IViewMethodMapper mapper
    ViewConflictResolveStrategy conflictStrategy = ViewConflictResolveStrategy.DEFAULT
}

enum ViewConflictResolveStrategy {
    THROW,
    WARNING,
    SKIP,
    OVERWRITE,

    ;

    public static final ViewConflictResolveStrategy DEFAULT = THROW
}
