package io.tswf.groovy.bettergroovy.asm.view.reading

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.view.annotation.OnConflict
import io.tswf.groovy.bettergroovy.asm.view.meta.ViewConflictResolveStrategy
import io.tswf.groovy.bettergroovy.asm.view.meta.ViewMethodMetadata

@CompileStatic
class ConflictStrategyReader {

    static ViewConflictResolveStrategy readConflictStrategy(ViewMethodMetadata viewMethodMeta) {
        def viewMethod = viewMethodMeta.viewMethod
        def onConflictAnnotation = viewMethod.findAnnotationByType(OnConflict)
        if (onConflictAnnotation != null) {
            return onConflictAnnotation.getValueByName("value", ViewConflictResolveStrategy)
        }

        return ViewConflictResolveStrategy.DEFAULT
    }
}
